/**
 * 读取资源表，生成 seajs 配置文件，
 * 关于seajs-config的配置表， fis-common 生成一个，特定项目生成一个
 */

'use strict';

var endOfLine = require('os').EOL;

module.exports = function(ret, settings, conf, opt){
    var conf = {
        'map': [],
        'pkg': []
    };

    fis.util.map(ret.map.res, function(id, res){
        var resType = res.type;
        if ( ( resType == 'js' || resType == 'css' ) && neddSeajsConfig( id ) ) {
            // 本地开发, 并且不是相对协议的。因为 seajs.data.base 后面包含了一个 /
            if ( res.uri[0] == '/' && res.uri[1] != '/'  ) {
                conf.map.push([ id, res.uri.substring(1) ]);
            } else {
                conf.map.push([ id, res.uri ]);
            }
        }
    });

    fis.util.map(ret.map.pkg, function(id, pkg){
        fis.util.map( pkg.has, function( id, data ){
            conf.pkg.push( [ data, pkg.uri.substring(1) ]);
        });
    });

    var seajs_config = fis.file(fis.project.getProjectPath(), 'static', 'seajs-config.js');


    var originalContent = '';
    if ( seajs_config.exists() ) {
        originalContent = seajs_config.getContent();
    }

    seajs_config.setContent( originalContent
        + endOfLine
        + 'seajs.config(' + JSON.stringify(conf, null, opt.optimize ? null : 4) + ');'
    );

    var id = seajs_config.id;

    ret.map.res[id] = {
        "uri": seajs_config.getUrl(opt.hash, opt.domain),
        "type": "js"
    };

    ret.pkg[seajs_config.subpath] = seajs_config;
};

function neddSeajsConfig( id ) {
    var ns = fis.config.get('namespace');
    var staticPath;

    if ( ns ) {
        staticPath = ns + fis.config.get('namespaceConnector', ':') + 'static';
    }

    return id.indexOf('seajs-config') < 0 && id.indexOf( staticPath + '/lib' ) < 0;
}